#ifndef __COUCHDB_RESULT_H__
#define __COUCHDB_RESULT_H__
G_BEGIN_DECLS

#include <glib-object.h>

#define COUCHDB_TYPE_RESULT                (couchdb_result_get_type ())
#define COUCHDB_RESULT(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), COUCHDB_TYPE_RESULT, CouchdbResult))
#define COUCHDB_IS_RESULT(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COUCHDB_TYPE_RESULT))
#define COUCHDB_RESULT_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), COUCHDB_TYPE_RESULT, CouchdbResultClass))
#define COUCHDB_IS_RESULT_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), COUCHDB_TYPE_RESULT))
#define COUCHDB_RESULT_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), COUCHDB_TYPE_RESULT, CouchdbResultClass))

typedef struct _CouchdbResult CouchdbResult;
typedef struct _CouchdbResultClass CouchdbResultClass;
typedef struct _CouchdbResultPrivate CouchdbResultPrivate;

struct _CouchdbResult {
	GObject parent;

	CouchdbResultPrivate *priv;
};

struct _CouchdbResultClass {
	GObjectClass parent_class;
};

GType couchdb_result_get_type (void);

CouchdbResult * couchdb_result_new (void);

gboolean couchdb_result_is_reduced (CouchdbResult * self);
const GSList * couchdb_result_get_document_list (CouchdbResult * self);
const GSList * couchdb_result_get_reduce_list (CouchdbResult * self);
gsize couchdb_result_get_total_count (CouchdbResult * self);
guint couchdb_result_get_offset (CouchdbResult * self);

G_END_DECLS

#endif /* __COUCHDB_RESULT_RESULT_H__ */
